module Main where

import System.Environment (getArgs)
import Control.Monad (guard)
import System.Exit
import Serial
import Parallel

main :: IO ()
main = do
  parsed <- getArgs >>= parseArgs
  result <- case parsed of [source, target] -> bfs source target
                           [source,target,numWorkers] -> parbfs (source, target) numWorkers
  putStrLn $ show result
  where parseArgs [source, target] = do
          let sourceInt = read source::Int
              targetInt = read source::Int
          return [ sourceInt,targetInt]
        parseArgs [source, target, numWorkers] = do
          let sourceInt = read source::Int
              targetInt = read source::Int
              numWorkersInt = read source::Int
          return [ sourceInt, targetInt, numWorkersInt ]
        parseArgs _ = System.Exit.die "Usage: (SERIAL) ./sixdegrees <sourcepageid> <targetpageid> \n (PARALLEL) ./sixdegrees <sourcepageid> <targetpageid> <numWorkers>\nExample: ./sixdegrees 12 10113"
